﻿namespace EF;

using static Console;

class Program
{
    static void podglądBazyDanych(BazaDanychOsób db)
    {
        try
        {
            WriteLine("Podgląd danych:");
            WriteLine("Osoby:");
            foreach (Osoba osoba in db.Osoby)
                WriteLine(osoba);
            WriteLine("Adresy:");
            foreach (Adres adres in db.Adresy)
                WriteLine(adres);
        }
        catch (Exception ex)
        {
            WriteLine("Błąd podglądu bazy danych: " + ex.ToString());
        }
    }

    static void dodajPrzykładoweOsoby(BazaDanychOsób db)
    {
        Adres adres1 = new Adres()
        {
            Id = 1,
            Miasto = "Toruń",
            Ulica = "Grudziądzka",
            NumerDomu = 5,
            NumerMieszkania = 477
        };

        Adres adres2 = new Adres()
        {
            Id = 2,
            Miasto = "Toruń",
            Ulica = "Pod Mostem",
            NumerDomu = 1
        };

        Osoba osoba1 = new Osoba()
        {
            Imię = "Antoni",
            Nazwisko = "Gburek",
            NumerTelefonu = 123456,
            Adres = adres1
        };

        Osoba osoba2 = new Osoba()
        {
            Imię = "Henryk",
            Nazwisko = "Garncarz",
            NumerTelefonu = 9876554,
            Adres = adres2
        };

        Osoba osoba3 = new Osoba()
        {
            Imię = "Wincenty",
            Nazwisko = "Patyk",
            NumerTelefonu = 12344765,
            Adres = adres1
        };

        db.DodajOsobę(osoba1);
        db.DodajOsobę(osoba2);
        db.DodajOsobę(osoba3);
    }

    static void pokażIdentyfikatoryOsób(BazaDanychOsób db)
    {
        string s = "Identyfikatory osób:";
        foreach (int idOsoby in db.IdentyfikatoryOsób)
            s += idOsoby.ToString() + ";";
        WriteLine(s.Trim(' ', ';'));
    }

    static void pokażOsoby(BazaDanychOsób db)
    {
        foreach (int idOsoby in db.IdentyfikatoryOsób)
        {
            WriteLine(db[idOsoby].ToString());
        }
    }

    static void Main(string[] args)
    {
        string dbName = "osoby.db";
        if(File.Exists(dbName)) File.Delete(dbName);

        BazaDanychOsób db = new BazaDanychOsób();

        dodajPrzykładoweOsoby(db);
        pokażIdentyfikatoryOsób(db);
        podglądBazyDanych(db);

        WriteLine("Osoby:");
        pokażOsoby(db);

        /*
        int idUsuwanejOsoby = 1;
        WriteLine($"Usuwam osobę nr {idUsuwanejOsoby}");
        db.UsuńOsobę(idUsuwanejOsoby);
        podglądBazyDanych(db);
        */

        db[1] = new Osoba() { Imię = "Jan", Nazwisko = "Kowalski", Adres = new Adres() { Miasto = "Toruń", Ulica = "Mostowa", NumerDomu = 100, NumerMieszkania = 20 } };
        podglądBazyDanych(db);
    }

    static void _Main(string[] args)
    {
        BazaDanychOsób db = new BazaDanychOsób();
        podglądBazyDanych(db);
    }
}
